<?php
//AUTO NEW ORDER CALL
//if enabled automatically sends call to customers 
add_action('woocommerce_new_order', 'bsp_robo_call_new_order', 10, 3);
function bsp_robo_call_new_order($order_id) {
	$robo_settings = bsp_robo_get_settings();
	if( !$robo_settings) { return false; }
	$robo_settings = $robo_settings[0];
	$bsp_robo_enable_order_new = $robo_settings->enable_auto_call;

	if($bsp_robo_enable_order_new == 1) {
		bsp_robo_send_call($order_id, 'New Order');
	}
}

// ROBO AJAX SEND CALL
add_action('wp_ajax_bsp_robo_send_call_ajax', 'bsp_robo_send_call_ajax');
function bsp_robo_send_call_ajax() {
	$order_id = $_POST['order_id'];
	if($order_id) {
		bsp_robo_send_call($order_id, 'New Order');
	}
	exit();
}

// ERROR LOG FILE
function bsp_robo_call_errorlogs($content) {
	$abspath = ABSPATH."wp-content/plugins/robo-ivr-call-pakistan/assets/errorlog.txt";
	if(!file_exists($abspath)) {
		fopen($abspath,"wb");
	}
	$fp = fopen($abspath,"a");
	fwrite($fp,$content);
	fclose($fp);
}

// CHANGE ORDER STATUS Mannually
add_action('woocommerce_order_status_changed', 'bspivr_custom_order_status_change_action', 10, 4);
function bspivr_custom_order_status_change_action($order_id, $old_status, $new_status) {
	if (!$order_id){
        return;
    }
    if ($new_status === 'cancelled') {
        $bsp_ivr_id = get_post_meta($order_id, 'bsp_ivr_id', true);
		if($bsp_ivr_id) {
			$robo_settings = bsp_robo_get_settings();
			if(!$robo_settings) {return false;}
			$robo_settings = $robo_settings[0];
			$bsp_robo_email = $robo_settings->bspivr_email;
			$bsp_robo_key = $robo_settings->bspivr_key;
			$url='?delete&email='.$bsp_robo_email.'&key='.$bsp_robo_key.'&id='.$bsp_ivr_id;
			$ivr_response = wp_remote_retrieve_body(wp_remote_post('https://secure.h3techs.com/sms/api/get_call'.$url));
			$ivr_response = json_decode($ivr_response, true);
		}
    }
}

// SEND CALL
// sends  calls to customers for order confirmation
function bsp_robo_send_call($order_id, $order_type) {
	$robo_settings = bsp_robo_get_settings();
	if(!$robo_settings) {return false;}

	$robo_settings = $robo_settings[0];

	$bsp_robo_email					 = $robo_settings->bspivr_email;
	$bsp_robo_key 					 = $robo_settings->bspivr_key;
	$bsp_robo_voiceid 				 = $robo_settings->bspivr_voiceid;
	$bsp_robo_enable_confirmed_order = $robo_settings->enable_confirmed_order;	
	$bsp_robo_enable_cancelled_order = $robo_settings->enable_cancelled_order;
	$bsp_robo_enable_callback_order  = $robo_settings->enable_callback_order;
	$bsp_robo_billing_phone 		 = $robo_settings->billing_phone;
	$bsp_robo_international_calls 	 = $robo_settings->international_calls;
	$bsp_robo_cod 					 = $robo_settings->cod;
	$bsp_robo_bacs 					 = $robo_settings->bacs;
	$bsp_robo_cheque 				 = $robo_settings->cheque;
	$bsp_robo_other 				 = $robo_settings->other;

	$order = new WC_Order($order_id);

	//custom order number  
	$bsp_alg_array = get_post_meta($order_id, '_alg_wc_full_custom_order_number', '' );
	$bsp_wcj_array = get_post_meta($order_id, '_wcj_order_number', '' );
	if(isset($bsp_alg_array[0])) {
		$order_number = $bsp_alg_array[0];
	} elseif(isset($bsp_wcj_array[0])) {
		$order_number = $bsp_wcj_array[0];
	} else {
		$order_number = $order->get_order_number();
	}
	//customized order number  end
	
	$order_gateway 	= $order->get_payment_method();
	$order_total 	= get_post_meta( $order_id, '_order_total', true );
	$order_total 	= (int)$order_total;
	$order_country 	= get_post_meta( $order_id, '_billing_country', true );
	$order_phone 	= get_post_meta( $order_id, '_billing_phone', true );
    $order_phone 	= trim($order_phone);
	$order_phone 	= preg_replace('/[^0-9]+/', '', $order_phone);

    $order_data = array(
    	'order_type' 	 => sanitize_text_field($order_type),
        'order_id' 		 => sanitize_text_field($order_id),
        'order_number' 	 => sanitize_text_field($order_number),
        'order_phone' 	 => sanitize_text_field($order_phone),
        'order_total' 	 => sanitize_text_field($order_total),
        'order_gateway'  => sanitize_text_field($order_gateway),
    );
	
	$bsp_error=array(
		"datetime"=>date("Y-m-d H:i:s"),
		"bsp_robo_email"=>$bsp_robo_email,
		"bsp_robo_voiceid"=>$bsp_robo_voiceid,
		"bsp_robo_enable_confirmed_order"=>$bsp_robo_enable_confirmed_order,
		"bsp_robo_enable_cancelled_order"=>$bsp_robo_enable_cancelled_order,
		"bsp_robo_enable_callback_order"=>$bsp_robo_enable_callback_order,
		"bsp_robo_billing_phone"=>$bsp_robo_billing_phone,
		"bsp_robo_international_calls"=>$bsp_robo_international_calls,
		"bsp_robo_cod"=>$bsp_robo_cod,
		"bsp_robo_bacs"=>$bsp_robo_bacs,
		"bsp_robo_cheque"=>$bsp_robo_cheque,
		"bsp_robo_other"=>$bsp_robo_other,
		"order_gateway"=>$order_gateway,
		"payment_method"=>$order->data["payment_method"],
		"total"=>$order->data["total"],
		"order_total"=>$order_total,
		"order_country"=>$order_country,
		"country"=>$order->data["billing"]["country"],
		"order_phone"=>$order_phone,
		"phone"=>$order->data["billing"]["phone"],
	);

	$check_bsp_ivr_id = get_post_meta($order_id, 'bsp_ivr_id', true);
	if(!empty($check_bsp_ivr_id)) {
		//bsp_robo_call_errorlogs("network");
		bsp_robo_call_errorlogs("Duplicate Call ".$order_phone);
		echo 'Duplicate: Call already sent to ' .$order_phone;
		return false;
	}

	$place_call = 0;

	if($order_country=="PK"){
		$order_phone = "92".substr($order_phone, -10);
		if(strlen($order_phone)!=12) { bsp_robo_call_errorlogs("Invalid Phone Number \n".print_r($bsp_error, true)); echo json_encode('Invalid Phone Number'); return false; }
		$phone_validate = substr($order_phone, 0, 4);
		$networks = array("9230", "9231", "9232", "9233", "9234", "9235");
		if (!in_array($phone_validate, $networks)) {
			bsp_robo_call_errorlogs("Network Error \n".print_r($bsp_error, true));
			echo json_encode('Invalid Phone Number');
			return false;
		}
	}

	if($bsp_robo_international_calls == 1 && $order_country!="PK") {
		$place_call = 1;
	}
	
	if($order_gateway == 'cod' && $bsp_robo_cod == 1) {
		$place_call = 1;
	}
	if($order_gateway == 'bacs' && $bsp_robo_bacs == 1) {
		$place_call = 1;
	}
	if($order_gateway == 'cheque' && $bsp_robo_cheque == 1) {
		$place_call = 1;
	}

	if($order_gateway != 'cod' && $order_gateway != 'bacs' && $order_gateway != 'cheque' && $order_gateway == 'other' && $bsp_robo_other == 1) {
		$place_call = 1;
	}

if($place_call==1) {
	$order_number = preg_replace("/[^0-9]/", "", $order_number);
	$url='?message='.$order_id.'&type=dtmf&email='.$bsp_robo_email.'&key='.$bsp_robo_key.'&voice_id='.$bsp_robo_voiceid. '&to='.$order_phone.'&order_id='.$order_id.'&order_number='.$order_number.'&amount='.$order_total;
	$ivr_response = wp_remote_retrieve_body(wp_remote_post('https://secure.h3techs.com/sms/api/send_voice'.$url));
	$ivr_response = json_decode($ivr_response, true);
	$ivr_message = $ivr_response['sms']['response'];

	if($ivr_response['sms']['code'] == '000') {
		$ivr_id 	  = $ivr_response['sms']['id'];

		update_post_meta($order_id,'bsp_ivr_id', $ivr_id);
		update_post_meta($order_id,'bsp_ivr_api', 'Sent');
		bsp_robo_insert_logs($order_data, $ivr_id, 'Sent');
		echo json_encode('Call sent successfully to '.$order_phone);
	} else {
		$ivr_api = 'Error';
		bsp_robo_call_errorlogs("BSP Server Returned Error (Code: ".$ivr_message.") \n".print_r($bsp_error, true));
		echo json_encode('Error: Call not sent to '.$order_phone.' - Error: '.$ivr_message);
	}
} else {
	bsp_robo_call_errorlogs("Call Error Multiple Reasons \n".print_r($bsp_error, true));
	echo json_encode('Call error - multiple reason # 136');
}
}

// ROBO AJAX GET CALL
add_action('wp_ajax_bsp_robo_get_call_ajax', 'bsp_robo_get_call_ajax');
function bsp_robo_get_call_ajax() {
	$ivr_id = sanitize_text_field($_POST['ivr_id']);
	$print  = sanitize_text_field($_POST['print']);
	if($ivr_id) {
		bsp_robo_get_call($ivr_id, $print);
	}
	exit();
}

// GET CALL
// get call status of customer's call if they confirmed/cancelled/not answered
function bsp_robo_get_call($ivr_id, $print) {
	
	$robo_settings = bsp_robo_get_settings();
	if( !$robo_settings) { return false; }
	$robo_settings = $robo_settings[0];

	$ivr_api_return					 = 'ivr_api_return';
	$bsp_robo_email					 = $robo_settings->bspivr_email;
	$bsp_robo_key					 = $robo_settings->bspivr_key;
	$bsp_robo_voiceid				 = $robo_settings->bspivr_voiceid;
	$bsp_robo_enable_order_confirmed = $robo_settings->enable_confirmed_order;
	$bsp_robo_enable_order_cancelled = $robo_settings->enable_cancelled_order;
	$bsp_robo_enable_order_callback  = $robo_settings->enable_callback_order;

	$ivr_response = wp_remote_retrieve_body(wp_remote_get('https://secure.h3techs.com/sms/api/get_call.php?email='.$bsp_robo_email.'&key='.$bsp_robo_key.'&id='.$ivr_id));
	$result = json_decode($ivr_response, true);

	if($result['sms']['code']==000) {
		if(empty($result['sms']['voice_dtmf'])) {
			//return;
			//echo json_encode('voice_dtmf empty');
		}
		global $wpdb;
		$order_id 	  	  = $result['sms']['voice_order_id'];
		$order 		      = wc_get_order($order_id);
		$order_status 	  = $order->get_status();
    	$ivr_dtmf 	  	  = $result['sms']['voice_dtmf'];
    	$ivr_status   	  = $result['sms']['voice_status'];
    	$ivr_api_return   = $result['sms']['voice_status_name'];
		$ivr_call = '';

		if($ivr_status == 4) { $ivr_call = 'ANSWER'; }
		$ivr_retry 	= 1;
		if($ivr_call == 'ANSWER' && $ivr_dtmf == 1) {
			$ivr_status = 'Confirmed';
			if($bsp_robo_enable_order_confirmed == 1 && $order_status == 'processing' || $order_status == 'on-hold') {
				$order->update_status('wc-callconfirmed');
			}
		} else if($ivr_call == 'ANSWER' && $ivr_dtmf == 2) {
			$ivr_status = 'Cancelled';
			if($bsp_robo_enable_order_cancelled == 1 && $order_status == 'processing' || $order_status == 'on-hold') {
				$order->update_status('wc-callcancelled');
			}
		} else if($ivr_call == 'ANSWER' && $ivr_dtmf == 3) {
			$ivr_status = 'Call Back';
			if($bsp_robo_enable_order_callback == 1 && $order_status == 'processing' || $order_status == 'on-hold') {
				$order->update_status('wc-callback');
			}
		} else {
			$ivr_status = null;	
		}

		//$ivr_api_return = $result['sms']['voice_status_name'];

		update_post_meta($order_id,'bsp_ivr_call', $ivr_call);
		update_post_meta($order_id,'bsp_ivr_status', $ivr_status);
		update_post_meta($order_id,'bsp_ivr_retry', $ivr_retry);
		update_post_meta($order_id,'ivr_api_return', $ivr_api_return);
		
		//call_que
		$ivr_response_que = wp_remote_retrieve_body(wp_remote_get('https://secure.h3techs.com/sms/api/get_call.php?email='.$bsp_robo_email.'&key='.$bsp_robo_key.'&que&id='.$ivr_id));
		$result_que = json_decode($ivr_response_que, true);
		$que_log="";
		if(isset($result_que["sms"]["code"]) && $result_que["sms"]["code"]=="000"){
			foreach($result_que as $que_result){
				$que_log.=$que_result["data"];
			}
		}
		//call_que end 
		$dbData = array();
        $dbData['ivr_call_que'] = $que_log;
        $wpdb->update($wpdb->prefix. 'bsp_robo_logs', $dbData, array('ivr_id' => $ivr_id));

		$dbData = array();
        $dbData['ivr_api_return'] = $ivr_api_return;
        $wpdb->update($wpdb->prefix. 'bsp_robo_logs', $dbData, array('ivr_id' => $ivr_id));

        $dbData = array();
        $dbData['ivr_call'] = $ivr_call;
        $wpdb->update($wpdb->prefix. 'bsp_robo_logs', $dbData, array('ivr_id' => $ivr_id));

        $dbData = array();
        $dbData['ivr_status'] = $ivr_status;
        $wpdb->update($wpdb->prefix.'bsp_robo_logs', $dbData, array('ivr_id' => $ivr_id));

        $dbData = array();
        $dbData['ivr_retry'] = $ivr_retry;
        $wpdb->update($wpdb->prefix.'bsp_robo_logs', $dbData, array('ivr_id' => $ivr_id));

        $dbData = array();
        $dbData['ivr_logs'] = $ivr_response;
        $wpdb->update($wpdb->prefix.'bsp_robo_logs', $dbData, array('ivr_id' => $ivr_id));
	} else {
		echo json_encode('API Connectivity Error - '.$result['sms']['response']); die();
	}
	
	if($print == 'yes') { ?>
		<table class="table table-sm table-striped" style="font-size:14px">
		  	<thead>
		    	<tr>
			      	<th scope="col">Phone</th>
			      	<th scope="col">Input</th>
		      		<th scope="col">Duration</th>
		      		<th scope="col">Cost</th>
		      		<th scope="col">Status</th>
		      		<th scope="col">Ext. Status</th>
		    	</tr>
		  	</thead>
			<tbody>
				<?php
					$log = $result["sms"];
					echo '<tr>';
						echo '<td>'.$log['voice_to'].'</td>';
						echo '<td>'.$log['voice_dtmf'].'</td>';
						echo '<td>'.$log['voice_sec'].'</td>';
						echo '<td>'.$log['voice_unit'].'</td>';
						

						if($log['voice_status'] == '4' && $log['voice_dtmf'] == 1) {
							echo '<td> Confirmed </td>';
						}
						else if ($log['voice_status'] == '4' && $log['voice_dtmf'] == 2) {
							echo '<td> Cancelled </td>';
						}
						else if ($log['voice_status'] == '4' && $log['voice_dtmf'] == 3) {
							echo '<td> Call Back </td>';
						}
						else if($log['voice_status'] != '4' ) {
						 	echo '<td> Not Answered </td>';
						}	
						echo '<td>'.$log['voice_status_name'].'</td>';	
					echo '<tr>';
					?>
			</tbody>					  	
		</table>
	<?php
	}
}

// add new column for Robo Calls in wp orders page where we can send call manually
add_filter( 'manage_edit-shop_order_columns', 'bsp_robo_add_order_columns' );
function bsp_robo_add_order_columns($columns) {
    $columns['bsp_show_robo_call'] = 'Robo Calls';
    return $columns;
}

add_action('manage_shop_order_posts_custom_column', 'bsp_robo_add_order_posts_custom_column' );
function bsp_robo_add_order_posts_custom_column( $column ) {

    global $post;
    global $the_order;
    if ('bsp_show_robo_call' === $column){

		$bsp_ivr_id		= get_post_meta($post->ID, 'bsp_ivr_id', true);
	    $bsp_ivr_api	= get_post_meta($post->ID, 'bsp_ivr_api', true);
		$bsp_ivr_call	= get_post_meta($post->ID, 'bsp_ivr_call', true);
	    $bsp_ivr_status = get_post_meta($post->ID, 'bsp_ivr_status', true);

	     if($bsp_ivr_api == 'Sent') {
	    	if($bsp_ivr_status != 'Confirmed' && $bsp_ivr_status != 'Cancelled' && $bsp_ivr_status != 'Call Back') { ?>
	     		<button class="button-secondary" style="text-align: center;"  onclick="bsp_robo_get_call_js('<?= $bsp_ivr_id ?>')">Get Status</button>  
	<?php
		}
	}
		else if(empty($bsp_ivr_id)) { ?>
			<button type="button" class="button-primary" style="text-align: center;" onclick="return confirm('Are you sure, you want to send call?') && bsp_robo_send_call_js('<?= $post->ID ?>')">Send Call</button>
		<?php
		}
    }
}

// Add ROBO IVR ORDER META BOX
add_action( 'add_meta_boxes', 'bsp_robo_meta_box' );
function bsp_robo_meta_box() {
    add_meta_box(
        'bsp-robo_modal',
        'Robo Calls',
        'bsp_robo_meta_box_callback',
        'shop_order',
        'side',
        'core'
    );
}

// ROBO IVR META BOX CALL BACK
//mannually sends call to customers when they don't answer
function bsp_robo_meta_box_callback( $post ) {
	$bsp_ivr_id 		= get_post_meta($post->ID, 'bsp_ivr_id', true);
    $bsp_ivr_api 		= get_post_meta($post->ID, 'bsp_ivr_api', true);
    $bsp_ivr_retry 		= get_post_meta($post->ID, 'bsp_ivr_retry', true);
	$bsp_ivr_call		= get_post_meta($post->ID, 'bsp_ivr_call', true);
    $bsp_ivr_status 	= get_post_meta($post->ID, 'bsp_ivr_status', true);
	$ivr_api_return		= get_post_meta($post->ID, 'ivr_api_return', true);

    if($bsp_ivr_api == 'Sent') {
	    echo '<p><strong>ID:</strong> ' .$bsp_ivr_id. '</p>';
	    echo '<p><strong>Try:</strong> ' .$bsp_ivr_retry. '</p>';
	    if($bsp_ivr_id) {
	    	echo '<p><strong>Type:</strong> ' .$bsp_ivr_call. '</p>';
	    }
		if($bsp_ivr_status == 'Confirmed') {
	    	echo '<p><strong>Status:</strong> <span style="font-size: 14px;background: #198754; color: #ffffff;padding: 3px 10px;border-radius: 10px;">Call ' . $bsp_ivr_status . '</span></p>';
	    }
	    else if($bsp_ivr_status == 'Cancelled') {
			echo '<p><strong>Status:</strong> <span style="font-size: 14px;background: #dc3545; color: #ffffff;padding: 3px 10px;border-radius: 10px;">Call ' . $bsp_ivr_status . '</span></p>';
	    }
	    else if($bsp_ivr_status == 'Call Back') {
			echo '<p><strong>Status:</strong> <span style="font-size: 14px;background: #ffc107; color: #000000;padding: 3px 10px;border-radius: 10px;">' . $bsp_ivr_status . '</span></p>';
	    }
	    else {
	    	echo '<p><strong>Status:</strong></p>';
	    }
	    if($bsp_ivr_status != 'Confirmed' && $bsp_ivr_status != 'Cancelled' && $bsp_ivr_status != 'Call Back') {
    	?>
    		<button class="button-secondary" style="width: 100%;text-align: center;" onclick= "bsp_robo_get_call_js('<?= $bsp_ivr_id ?>')">Get Status</button>
    	<?php
    	}
	}
	else { ?>
		<button type="button" class="button-primary" style="width: 100%; text-align: center;" onclick="return confirm('Are you sure, you want to send call?') && bsp_robo_send_call_js('<?= $post->ID ?>')">Send Call</button>
	<?php
	}
	?>
<?php
}

// add order data in order table 
add_action( 'manage_shop_order_posts_custom_column' , 'bsp_robo_shop_order_posts_custom_column', 50, 2 );
function bsp_robo_shop_order_posts_custom_column( $column, $post_id ) {

    if ( $column == 'order_number' ) {
    	$bsp_ivr_id 	= get_post_meta($post_id, 'bsp_ivr_id', true);
    	$bsp_ivr_call 	= get_post_meta($post_id, 'bsp_ivr_call', true);
        $bsp_ivr_status = get_post_meta($post_id, 'bsp_ivr_status', true);
		
        if ($bsp_ivr_call) {
        	if($bsp_ivr_status == 'Confirmed') {
            	echo '<br><span style="font-size: 10px;float: left;line-height: initial;background: #c6e1c6;color: #5b841b; padding: 3px 10px;border-radius: 10px;">Call ' . $bsp_ivr_status . '</span>';
            }
            else if($bsp_ivr_status == 'Cancelled') {
				echo '<br><span style="font-size: 10px;float: left;line-height: initial;background: #e0c8c8;color: #822f2f; padding: 3px 10px;border-radius: 10px;">Call ' . $bsp_ivr_status . '</span>';
            }
            else if($bsp_ivr_status == 'Call Back') {
				echo '<br><span style="font-size: 10px;float: left;line-height: initial;background: #fce1a0;color: #836e2e; padding: 3px 10px;border-radius: 10px;">' . $bsp_ivr_status . '</span>';
            }
            else if(!empty($bsp_ivr_call)) {
            	$bsp_ivr_call = strtolower($bsp_ivr_call);
				echo '<br><span style="font-size: 10px;float: left;line-height: initial;background: #dedee0;color: #888888; padding: 3px 10px;border-radius: 10px;">' . ucfirst($bsp_ivr_call) . '</span>';            	
            }
            else {

            }
        }
    }
}

// registers order status
add_filter( 'woocommerce_register_shop_order_post_statuses', 'bsp_aoc_register_order_status' );
function bsp_aoc_register_order_status($order_statuses) {

   $order_statuses['wc-callconfirmed'] = array(                                 
   'label'                     => _x( 'Call Confirmed', 'Order status call confirmed', 'woocommerce' ),
   'public'                    => true,                            
   'exclude_from_search'       => false,                                 
   'show_in_admin_all_list'    => true,                                 
   'show_in_admin_status_list' => true,                                 
   'label_count'               => _n_noop( 'Call Confirmed <span class="count">(%s)</span>', 'Call Confirmed <span class="count">(%s)</span>', 'woocommerce' ),                              
   );

   $order_statuses['wc-callcancelled'] = array(                                 
   'label'                     => _x( 'Call Cancelled', 'Order status call cancelled', 'woocommerce' ),
   'public'                    => true,                            
   'exclude_from_search'       => false,                                 
   'show_in_admin_all_list'    => true,                                 
   'show_in_admin_status_list' => true,                                 
   'label_count'               => _n_noop( 'Call Cancelled <span class="count">(%s)</span>', 'Call Cancelled <span class="count">(%s)</span>', 'woocommerce' ),                              
   );

   $order_statuses['wc-callback'] = array(                                 
   'label'                     => _x( 'Call Back', 'Order status call back', 'woocommerce' ),
   'public'                    => true,                            
   'exclude_from_search'       => false,                                 
   'show_in_admin_all_list'    => true,                                 
   'show_in_admin_status_list' => true,                                 
   'label_count'               => _n_noop( 'Call Back <span class="count">(%s)</span>', 'Call Back <span class="count">(%s)</span>', 'woocommerce' ),                              
   );       
   return $order_statuses;
}

// shows status of single orders 
add_filter( 'wc_order_statuses', 'bsp_aoc_wc_order_statuses' );
function bsp_aoc_wc_order_statuses( $order_statuses ) {
    $order_statuses['wc-callconfirmed'] 	= _x( 'Call Confirmed', 'Order status', 'woocommerce' );
    $order_statuses['wc-callcancelled'] 	= _x( 'Call Cancelled', 'Order status', 'woocommerce' );
    $order_statuses['wc-callback'] 			= _x( 'Call Back', 'Order status', 'woocommerce' );
    return $order_statuses;	
}

// shows status of bulk orders
add_filter( 'bulk_actions-edit-shop_order', 'bsp_aoc_bulk_actions_edit_shop_order' );
function bsp_aoc_bulk_actions_edit_shop_order( $bulk_actions ) {
    $bulk_actions['mark_callconfirmed'] 	= 'Change status to call confirmed';
    $bulk_actions['mark_callcancelled'] 	= 'Change status to call cancelled';
    $bulk_actions['mark_callback'] 			= 'Change status to call back';
    return $bulk_actions;
}

// add status styling
add_action('admin_head', 'bsp_aoc_order_status_styling');
function bsp_aoc_order_status_styling() {

echo 
'<style>
    .status-callconfirmed {
        background: #c0ddfc;
        color: #0052a9;
        border: none;
    }
    .status-callcancelled {
        background: #e0c8c8;
        color: #822f2f;
        border: none;
    }
    .status-callback {
        background: #fce1a0;
        color: #836e2e;
        border: none;
    }                        
</style>';
}

// Add robo calls in database
function bsp_robo_insert_logs($order, $ivr_id, $ivr_api) {
    global $wpdb;
    $date = new DateTime("now", new DateTimeZone('Asia/Karachi'));

    $wpdb->insert($wpdb->prefix.'bsp_robo_logs', array(
        'shop_url' 			=> get_home_url(),
        'order_type' 		=> sanitize_text_field($order['order_type']),
        'order_id' 			=> sanitize_text_field($order['order_id']),
        'order_number' 		=> sanitize_text_field($order['order_number']),
        'order_phone' 		=> sanitize_text_field($order['order_phone']),
        'order_total' 		=> sanitize_text_field($order['order_total']),
        'order_gateway' 	=> sanitize_text_field($order['order_gateway']),
        'ivr_provider' 		=> 'BSP',
        'ivr_datetime' 		=> sanitize_text_field($date->format('Y-m-d H:i:s')),
        'ivr_id' 			=> sanitize_text_field(($ivr_id)),
        'ivr_api' 			=> sanitize_text_field(($ivr_api))
    ));
}

// Add courier filter
add_action( 'restrict_manage_posts', 'bsp_robo_add_filter_options' );
function bsp_robo_add_filter_options() {
    global $pagenow, $post_type;

    if( 'shop_order' === $post_type && 'edit.php' === $pagenow ) {
        $domain    = 'woocommerce';
        $current   = isset($_GET['bsp_filter_by_ivr'])? $_GET['bsp_filter_by_ivr'] : '';

        echo '<select name="bsp_filter_by_ivr">
        <option value="">' . __('Filter by IVR', $domain) . '</option>';

        $options = [
            'Confirmed' => __('Confirmed'),
            'Cancelled' => __('Cancelled'),
            'Call Back' => __('Call Back'),
        ];

        foreach ( $options as $key => $label ) {
            printf( '<option value="%s"%s>%s</option>', $key,
                $key === $current ? '" selected="selected"' : '', $label );
        }
        echo '</select>';
    }
}

add_filter( 'request', 'bsp_robo_process_filter_options', 99 );
function bsp_robo_process_filter_options( $vars ) {
    global $pagenow, $typenow;
    if ( $pagenow == 'edit.php' && isset( $_GET['bsp_filter_by_ivr'] ) 
        && $_GET['bsp_filter_by_ivr'] != '' && 'shop_order' === $typenow ) {
        $vars['meta_key']   = 'bsp_ivr_status';
        $vars['meta_value'] = wc_clean( $_GET['bsp_filter_by_ivr'] );
    }
    return $vars;
}

// display billing phone
add_action( 'manage_shop_order_posts_custom_column' , 'bsp_robo_orders_list_column', 50, 2 );
function bsp_robo_orders_list_column( $column, $post_id ) {

	$robo_settings = bsp_robo_get_settings();
	if( !$robo_settings) { return false; }
	$robo_settings = $robo_settings[0];

	$bsp_robo_billing_phone = $robo_settings->billing_phone;

	if($bsp_robo_billing_phone == 1) {
	    if ($column == 'billing_address' ) {
	        global $the_order;
	        if( $phone = $the_order->get_billing_phone() ) {
				echo '<br><span style="color:#555 !important">'.$phone.'</span><br>';
	        }
	    }
	}
}

// add footer script
add_action('admin_footer', 'bsp_robo_add_footer_scripts');
function bsp_robo_add_footer_scripts() {
	global $pagenow;
	if ( ($pagenow === 'post.php' && $_GET['action'] == 'edit') || ($pagenow === 'edit.php' && isset($_GET['post_type']) && $_GET['post_type'] == 'shop_order') ) { ?>
		<script type='text/javascript'>
			function bsp_robo_send_call_js(order_id) {
			    jQuery.ajax({
			        type: 'POST',
			        url: '<?php echo admin_url('/admin-ajax.php'); ?>',
			        data: {
			            'action': 'bsp_robo_send_call_ajax',
			            'order_id' : order_id,
			        },
			        success: function (ivr_response) {
						alert(ivr_response);
			        	console.log(ivr_response);
			        }
			    });
			}
		</script>
		<script type='text/javascript'>
			function bsp_robo_get_call_js(ivr_id) {
			    jQuery.ajax({
			        type: 'POST',
			        url: '<?php echo admin_url('/admin-ajax.php'); ?>',
			        data: {
			            'action': 'bsp_robo_get_call_ajax',
			            'ivr_id' : ivr_id,
			            'print' : "no",
			        },
			        success: function(ivr_response) {
			        	console.log(ivr_response);
			        },
			    });
			}
		</script>
	<?php
	}
}
?>